<?php

/**
 * Description: LAB Related Database Queries. 
 * @author ZALAK OZA
 */
class Lab_Modal {
private $connection;
    
    public function __construct($conn) {
        $this->connection = $conn;
    }
    /**
     * Description : Patient And Some Service Request Details
     * @param DatePeriod $selectedDate Date
     * @param integer $opd OPD
     * @param integer $ipd IPD
     * @param integer $patientId Patient ID 
     * @param integer $sampleID test ID 
     * @return object
     */
    function getPatientDetails_old($p_labTestDisplayWithoutPymt, $todate, $opd, $ipd, $patientId, $fromdate) {
        $qry1 = $p_labTestDisplayWithoutPymt == 'N' ? " AND ((sr.receipt_cat != '' AND sr.ipd_opd != '' AND sr.receipt_no != '') OR (v.visit_type = 'I')) " : "";
//        if($sampleID != 0){
//            $qry = "SELECT sr.`ipd_reg_id`,sr.`serial_no`,sr.`req_time`,sr.`opd_reg_id`,sr.`visit_id`,sr.`req_id`,sr.`req_date`,sr.`test_id`, sr.`fyear`, sr.`dept_seq_no`,sr.`report_print`, pm.`patient_name`,pm.`patient_id`,sr.`remark`,v.`dept_id`,de.`dept_name_eng`, sr.receipt_no, sr.receipt_cat, v.visit_type FROM service_request sr INNER JOIN `visit` v ON sr.`visit_id` = v.`visit_id` INNER JOIN `pateint_master` pm ON pm.`patient_id` = v.`patient_id`INNER JOIN `department` de ON v.`dept_id` = de.`dept_id` WHERE sr.`service_grp_cd` = 'LAB' AND sr.visit_id != 0 AND sr.test_id != 0 AND sr.`test_id`= '$sampleID' AND sr.`is_deleted` = 'N' $qry1 GROUP BY sr.`test_id` ORDER BY sr.`req_id` ";
//        } 
         if ($ipd != 0) {
            $qry = "SELECT sr.`ipd_reg_id`, sr.`serial_no`, sr.`req_time`, sr.`opd_reg_id`, sr.`visit_id`, sr.`req_id`, sr.`req_date`, sr.`test_id`, sr.`fyear`, sr.`dept_seq_no`, sr.`report_print`, pm.`patient_name`, pm.`patient_id`, sr.`remark`, v.`dept_id`, de.`dept_name_eng`, sr.receipt_no, sr.receipt_cat, v.visit_type, sr.`is_deleted` FROM service_request sr INNER JOIN `visit` v ON sr.`visit_id` = v.`visit_id` INNER JOIN `pateint_master` pm ON pm.`patient_id` = v.`patient_id` INNER JOIN `department` de ON v.`dept_id` = de.`dept_id` WHERE sr.`service_grp_cd` = 'LAB' AND sr.visit_id != 0 AND sr.test_id != 0 AND sr.`ipd_reg_id`= '$ipd' AND sr.`is_request_cancelled` = 'N' $qry1 GROUP BY sr.`test_id` ORDER BY sr.`req_id` ";
        } else if ($opd != 0) {
            $qry = "SELECT sr.`ipd_reg_id`,sr.`serial_no`,sr.`req_time`,sr.`opd_reg_id`,sr.`visit_id`,sr.`req_id`,sr.`req_date`,sr.`test_id` ,sr.`fyear` , sr.`dept_seq_no`,sr.`report_print`,pm.`patient_name`,pm.`patient_id`,sr.`remark`,v.`dept_id`,de.`dept_name_eng`, sr.receipt_no, sr.receipt_cat, v.visit_type, sr.`is_deleted` FROM service_request sr INNER JOIN `visit` v ON sr.`visit_id` = v.`visit_id` INNER JOIN `pateint_master` pm ON pm.`patient_id` = v.`patient_id` INNER JOIN `department` de ON v.`dept_id` = de.`dept_id` WHERE sr.`service_grp_cd` = 'LAB' AND sr.visit_id != 0 AND sr.test_id != 0 AND sr.`opd_reg_id`= '$opd' AND sr.`is_request_cancelled` = 'N' $qry1 GROUP BY sr.`test_id` ORDER BY sr.`req_id` ";
        }else if ($patientId != 0) {
            //$resultOpdList = implode("','", $this->getAllVisit($patientId));
            $qry = "SELECT sr.`ipd_reg_id`, sr.`serial_no`, sr.`req_time`, sr.`opd_reg_id`, sr.`visit_id`, sr.`req_id`, sr.`req_date`, sr.`test_id`, sr.`fyear`, sr.`dept_seq_no`, sr.`report_print`, pm.`patient_name`, pm.`patient_id`, sr.`remark`, v.`dept_id`, de.`dept_name_eng`, sr.receipt_no, sr.receipt_cat, v.visit_type, sr.`is_deleted` FROM service_request sr INNER JOIN `visit` v ON sr.`visit_id` = v.`visit_id` INNER JOIN `pateint_master` pm ON pm.`patient_id` = v.`patient_id` INNER JOIN `department` de ON v.`dept_id` = de.`dept_id` WHERE sr.`service_grp_cd` = 'LAB' AND sr.visit_id != 0 AND sr.test_id != 0 AND v.`patient_id` = '$patientId' AND sr.`is_request_cancelled` = 'N' $qry1 GROUP BY sr.`test_id` ORDER BY sr.`req_id` ";
            } else if (!empty($todate) && (!empty ($fromdate)) && $ipd == 0 && $opd == 0 && $patientId == 0) {
            $qry = "SELECT sr.`ipd_reg_id`, sr.`serial_no`, sr.`req_time`, sr.`opd_reg_id`, sr.`visit_id`, sr.`req_id`, sr.`req_date`, sr.`test_id`, sr.`fyear`, sr.`dept_seq_no`, sr.`report_print`, pm.`patient_name`, pm.`patient_id`, sr.`remark`, v.`dept_id`, de.`dept_name_eng`, sr.receipt_no, sr.receipt_cat, v.visit_type, sr.`is_deleted` FROM service_request sr INNER JOIN `visit` v ON sr.`visit_id` = v.`visit_id` INNER JOIN `pateint_master` pm ON pm.`patient_id` = v.`patient_id` INNER JOIN `department` de ON v.`dept_id` = de.`dept_id` WHERE sr.`service_grp_cd` = 'LAB' AND sr.visit_id != 0 AND sr.test_id != 0 AND sr.`req_date` BETWEEN '$fromdate' AND '$todate' AND sr.`is_request_cancelled` = 'N' $qry1 GROUP BY sr.`test_id` ORDER BY sr.`serial_no` ";
        }

        $qryResult = mysqli_query($this->connection, $qry);
        while ($row = mysqli_fetch_object($qryResult)) {
            $result[] = $row;
        }
        return $result;
    }
    
    function getPatientDetails($p_labTestDisplayWithoutPymt, $todate, $opd, $ipd, $patientId, $fromdate, $status = "danger",$test_classification) {
        $labTestShowQry = $p_labTestDisplayWithoutPymt == 'N' ? " AND ((sr.receipt_cat != '' AND sr.ipd_opd != '' AND sr.receipt_no != '') OR (v.visit_type = 'I')) " : "";

        $labQry = "SELECT sr.serial_no, sr.`ipd_reg_id`, sr.`req_time`, sr.`opd_reg_id`, sr.`visit_id`, sr.`req_id`, sr.`req_date`, sr.`test_id`, sr.`fyear`, sr.`dept_seq_no`, sr.`report_print`, pm.`patient_name`, pm.`patient_id`, sr.`remark`, v.`dept_id`, de.`dept_name_eng`, sr.receipt_no, sr.receipt_cat, v.visit_type,v.emergencyVisit, sr.`is_deleted`, 
        COUNT(CASE WHEN flag='R' THEN 1 END) AS test_requested_count,
        COUNT(CASE WHEN flag='U' THEN 1 END) AS test_updated_count,
        COUNT(CASE WHEN flag='P' THEN 1 END) AS test_print_count
        FROM
            service_request sr
        INNER JOIN visit v ON
            v.visit_id = sr.visit_id
        INNER JOIN `pateint_master` pm ON pm.`patient_id` = v.`patient_id`
         INNER JOIN `department` de ON v.`dept_id` = de.`dept_id` 
         INNER JOIN lab_request lr ON lr.test_id = sr.test_id
         INNER JOIN test_group_master tgm ON tgm.test_grp_cd  = lr.test_grp_cd
        WHERE
            sr.`service_grp_cd` = 'LAB' AND sr.visit_id != 0 AND sr.test_id != 0 ";
        if ($ipd != 0) {
            $labQry .= " AND sr.`ipd_reg_id`= '$ipd' ";
        } else if ($opd != 0) {
            $labQry .= " AND sr.`opd_reg_id`= '$opd' ";
        } else if ($patientId != 0) {
           $labQry .= " AND v.`patient_id` = '$patientId' ";
        } else if (!empty($todate) && (!empty($fromdate)) && $ipd == 0 && $opd == 0 && $patientId == 0) {
           $labQry .= " AND sr.`req_date` BETWEEN '$fromdate' AND '$todate' ";
        }
          if($test_classification != 'all'){
          $labQry .= "AND tgm.test_classification = '$test_classification'" ;
        }
        $labQry .=  " AND sr.`is_request_cancelled` = 'N' $labTestShowQry Group by test_id ";
      
        if($status == "danger"){
            $labQry .= " having (test_requested_count >= 1)";
        }
        
        if($status == "info"){
            $labQry .= " having (test_requested_count = 0 and test_updated_count >= 1)";
        }
        
        if($status == "success"){
            $labQry .= " having (test_requested_count = 0 and test_updated_count = 0 and test_print_count >= 0)";
        }
        
        $labQry .= " ORDER BY sr.serial_no";

        $qryResult = mysqli_query($this->connection, $labQry);
        while ($row = mysqli_fetch_object($qryResult)) {
            $result[] = $row;
        }
        return $result;
    }

    /**
     * Description : Get Lab Request Details
     * @param integer $testId
     * @param integer $fYear
     * @return object
     */
    function getServiceDetails($testId, $fYear) {
        $qryResult = mysqli_query($this->connection, "SELECT lr.*, sm.`service_desc` FROM `lab_request` lr "
                . "INNER JOIN `service_master` sm ON lr.`service_cd` = sm.`service_cd`"
                . "WHERE lr.`test_id` = '$testId' AND lr.`fYear` = '$fYear' AND lr.`flag` != 'D' "
                . "ORDER BY lr.`lab_req_id` ");
        while ($row = mysqli_fetch_object($qryResult)) {
            $result[] = $row;
        }
        return $result;
    }

    /**
     * Description : Delete Service Request
     * @param string $serviceReqId
     * @param integer $fYear
     * @return boolean
     */
    function deleteServiceRequest($serviceReqId, $fYear) {
        $userId = $_SESSION['user_id'];
        return mysqli_query($this->connection, "UPDATE `lab_request` SET `flag` = 'D',LastModifiedBy = '$userId',LastModifiedDate = NOW() WHERE `service_req_id` = '$serviceReqId' AND `fyear` = '$fYear' ");
    }

    /**
     * Description : Check Multiple Print Flag Y or N 
     * @param integer $testId
     * @param DatePeriod $selectedDate
     * @return object
     */
    function checkMultiplePrintFlag($testId, $selectedDate) {
        return mysqli_fetch_object(mysqli_query($this->connection, "SELECT count(*) as status FROM `lab_request` WHERE `test_id` = '$testId' AND `req_date` = '$selectedDate' AND `flag`  != 'U' AND `flag`  != 'D' AND `flag`  != 'P' "));
    }

    /**
     * Description : Check Multiple Dept Flag Means Inserted Or Not 
     * @param integer $serviceReqId
     * @param integer $fyear
     * @return object
     */
    function checkMultipleDeptNoFlag($serviceReqId, $fyear) {
        return mysqli_fetch_object(mysqli_query($this->connection, "SELECT count(*) as result_flag FROM `lab_request` WHERE `service_req_id` = '$serviceReqId' AND `fyear` = '$fyear' AND `flag` != 'R' "));
    }

    /**
     * Description: Update Multiple PrintReport Flag.
     * @param string $testId
     * @param string $fYear
     * @return boolean
     */
    function updateMultipleReportPrintResult($testId, $fYear, $userId) {
        return mysqli_query($this->connection, "UPDATE `lab_request` SET `flag` = 'P', print_datetime = '".date('Y-m-d H:i:s')."', LastModifiedBy = '$userId', `LastModifiedDate` = NOW() WHERE `test_id` = '$testId' AND `fyear`= '$fYear' AND `flag` != 'D' AND `flag` != 'P' ");
    }

    /**
     * Description: Update Specific PrintReport Flag.
     * @param string $labReqId
     * @return boolean
     */
    function updateSpecificReportPrintResult($labReqId, $fYear, $userId) {
        return mysqli_query($this->connection, "UPDATE `lab_request` SET `flag` = 'P', print_datetime = '".date('Y-m-d H:i:s')."',LastModifiedBy = '$userId', `LastModifiedDate` = NOW() WHERE `lab_req_id` IN ('$labReqId') AND fyear='$fYear' AND flag != 'D' AND `flag` != 'P'");
    }

    /**
     * Description: Update Remark In Service Req.
     * @param string $reqId
     * @param string $fYear
     * @param string $note
     * @return boolean
     */
    function updateRemarkNote($reqId, $fYear, $note) {
        return mysqli_query($this->connection, "UPDATE `service_request` SET remark = '$note',last_update_date = CURDATE() WHERE req_id IN('$reqId') AND fyear= '$fYear' AND  service_grp_cd = 'LAB' AND `is_deleted` = 'N' ");
    }

    /**
     * Description : Max Lab Req Id
     * @return integer
     */
    function getMaxLabReqId() {
        $result = mysqli_fetch_object(mysqli_query($this->connection, "SELECT MAX(lab_req_id) AS Max_Lab_Req FROM `lab_request` LIMIT 1 "));
        return intval($result->Max_Lab_Req);
    }

    /**
     * Description : Insert Lab Request.
     * @param integer $labReqId Lab Req ID
     * @param integer $testId Test ID
     * @param integer $serviceReqId Service Req ID
     * @param integer $fyear F-year
     * @param integer $visitId Visit ID
     * @param date $reqDate Request Date
     * @param integer $opd OPD
     * @param integer $ipd IPD
     * @param integer $serviceCode Service Code
     * @param integer $testGroupCode Test Group Code
     * @param string $reqDiv Request Date
     * @param string $userId UserID
     * @param string $flag Flag
     * @return boolean
     */
    function insertLabRequest($labReqId, $testId, $serviceReqId, $fyear, $visitId, $reqDate, $opd, $ipd, $serviceCode, $testGroupCode, $reqDiv, $userId, $flag) {
        return mysqli_query($this->connection, "insert into lab_request set test_id = '$testId', service_req_id = '$serviceReqId',  fyear = '$fyear', visit_id = '$visitId', req_date = '$reqDate', req_time = '$currentTime', opd_reg_id = '$opd', ipd_reg_id = '$ipd',service_cd = '$serviceCode',test_grp_cd = '$testGroupCode',request_division = '$reqDiv',user_id = '$userId',flag = '$flag' ");
    }

    /**
     * Description : Lab Request Details
     * @param integer $labReqId
     * @return object
     */
    function getLabRequestResult($labReqId) {
        return mysqli_fetch_object(mysqli_query($this->connection, "SELECT * FROM `lab_request` WHERE `lab_req_id` = '$labReqId' LIMIT 1 "));
    }

    /**
     * Description : Check Service Bill Status 
     * @param integer $serviceReqId
     * @param integer $fYear
     * @return object
     */
    function checkBillStatus($serviceReqId, $fYear) {
        return mysqli_fetch_object(mysqli_query($this->connection, "SELECT count(*) as status FROM `lab_request` WHERE `service_req_id` = '$serviceReqId' AND `fyear` = '$fYear' AND `flag` = 'I' OR `flag` = 'O' "));
    }

    /**
     * Description : Check Service Req Is Removable Or Not
     * @param integer $serviceReqId
     * @param integer $fYear
     * @return object
     */
    function checkServiceRequestRemovable($serviceReqId, $fYear) {
        return mysqli_fetch_object(mysqli_query($this->connection, "SELECT count(*) as status FROM `lab_request` WHERE request_division NOT IN('A','I','O') AND flag = 'U' OR flag = 'P'  AND `service_req_id` = '$serviceReqId' AND `fyear` = '$fYear' "));
    }

    /**
     * Description : Count For Multiple Lab Req, Update, Print Flag for Color changes
     * @param integer $testId
     * @param integer $fYear
     * @param string $flagType
     * @return integer
     */
    function countMultipleFlag($testId, $fYear, $flagType) {
        $result = mysqli_fetch_object(mysqli_query($this->connection, "SELECT COUNT(*) AS `status`  FROM `lab_request` WHERE `test_id` = '$testId' AND `fYear` = '$fYear' AND flag = '$flagType' "));
        return $result->status;
    }

    /**
     * Description : Get Lab request division 
     * @param integer $labReqId
     * @param integer $fYear
     * @return string
     */
    function getRequestDivision($labReqId, $fYear) {
        $result = mysqli_fetch_object(mysqli_query($this->connection, "SELECT `request_division`  FROM `lab_request` WHERE `lab_req_id` = '$labReqId' AND `fYear` = '$fYear' LIMIT 1  "));
        return $result->request_division;
    }

    /**
     * Description : Check Any Updated Or Printed For Service Request Id 
     * @param integer $serviceReqId
     * @param integer $fYear
     * @return integer
     */
    function checkUpdatedOrPrinted($serviceReqId, $fYear) {
        $result = mysqli_fetch_object(mysqli_query($this->connection, "SELECT count(*) AS Flag  FROM `lab_request` WHERE `service_req_id` = '$serviceReqId' AND `fYear` = '$fYear' AND (flag = 'U' OR flag = 'P') "));
        return intval($result->Flag);
    }

    /**
     * Description : Get All OPD ID
     * @param integer $patientId
     * @return object
     */
    function getAllVisit($patientId) {
        $qryResult = mysqli_query($this->connection, "SELECT `visit_id` FROM `visit` WHERE `patient_id` = '$patientId'  ");
        while ($row = mysqli_fetch_object($qryResult)) {
            $result[] = $row->visit_id;
        }
        return $result;
    }

     /**
     * Description : Get test Description
     * @param string $testCode (coma seperated eg: T001,T002)
     * @return string
     */
    function labTestDescription($testCode){
        $testCode = str_replace(",", "','", $testCode);
        $testQry = mysqli_query($this->connection, "SELECT test_desc FROM `patho_test_master` WHERE `test_cd` IN ('$testCode') ORDER BY FIELD(`test_cd`, '$testCode') ");
        $testDesc = '';
        while ($testRow = mysqli_fetch_object($testQry)):
            $testDesc .= ', ';
            $testDesc .= $testRow->test_desc;
        endwhile;
        return substr($testDesc, 2);
    }
    
     /**
     * Description : Get test Group Description
     * @param string $testGroupCode (coma seperated eg: T001,T002)
     * @return string
     */
    function labTestGroupDescription($testGroupCode){
        $testGroupCodeIn = str_replace(",", "','", $testGroupCode);
        $groupQry = mysqli_query($this->connection, "SELECT test_grp_desc FROM `test_group_master` WHERE `test_grp_cd` IN ('$testGroupCodeIn') ORDER BY FIND_IN_SET(test_grp_cd, '$testGroupCode')");
        $groupDesc = '';
//        var_dump("SELECT test_grp_desc FROM `test_group_master` WHERE `test_grp_cd` IN ('$testGroupCode')");
        while ($groupRow = mysqli_fetch_object($groupQry)):
            $groupDesc .= ', ';
            $groupDesc .= $groupRow->test_grp_desc;
        endwhile;
        return substr($groupDesc, 2);
    }
    
    function checkSensitivity($testGroupCode){
        $groupRow = mysqli_fetch_object(mysqli_query($this->connection, "SELECT test_type FROM `test_group_master` WHERE `test_grp_cd` = '$testGroupCode'"));
        return $groupRow->test_type == 'Sensitivity' ? TRUE : FALSE;
    }
    
    function checkSensitiveModerateResistant($resistant, $moderate, $sensitive, $result) {
        $checkResistant = "$result$resistant";
        $referenceZone1 = eval('return '.$checkResistant.';');
        $moderateArray = explode('-', $moderate); 
        $checkSensitive = "$result$sensitive";
        $referenceZone3 = eval('return '.$checkSensitive.';');
        if($result == ''){
            $return = '';
        } else if($referenceZone1 == TRUE){
            $return = 'Resistant';
        } else if($result >= $moderateArray[0] && $result <= $moderateArray[1]){
            $return = 'Moderate';
        } else if($referenceZone3 == TRUE){
            $return = "Sensitive";
        } else {
            $return = '';
        }
        return $return;
    }
    
    function labTestDetail($testCode) {
        return mysqli_fetch_object(mysqli_query($this->connection, "SELECT `test_cd`, `sample_cat`, `exam_cat`, `test_desc`, `additional_test_desc`, `default_value`, `sub_result`, `formula`, `range_note`, `unit`, `m_min`, `m_max`, `f_min`, `f_max`, `lab_category`, `active_YN` FROM `patho_test_master` WHERE active_YN = 'Y' AND lab_category = 'N' AND test_cd = '$testCode' "));
    }
}
